Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • Table of contents

    Integration with jQuery

    This tutorial will help you integrate the pivot table with the jQuery library. We provide the following options:

    1. Run the sample project from GitHub
    2. Integrate Flexmonster into a jQuery application

    Run the sample project from GitHub

    Step 1. Download the project

    Download a .zip archive with the sample project or clone it from GitHub with the following command:

    git clone https://github.com/flexmonster/pivot-jquery

    Step 2. See the results

    Open the pivot-jquery/index.html file in the browser to see the result.

    Integrate Flexmonster into a jQuery application

    If you already have a project with jQuery, jump to Step 2. Add Flexmonster. Otherwise, follow the steps below to set up a simple project:

    Step 1. Create a new jQuery project

    1. Create a new folder for the project, e.g. my-jquery-project/.
    2. Create an index.html file inside my-jquery-project/ and include jQuery:
      <!DOCTYPE html>
      <html>
      <head>
      <title>My jQuery/Flexmonster Project</title>
      </head>
      <body>
      <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
      </body>
      </html>

    Step 2. Add Flexmonster

    Add the Flexmonster library to index.html:

    <!DOCTYPE html>
    <html>
      <head>
        <title>My jQuery/Flexmonster Project</title>
      </head>
      <body>
        <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
        <script src="https://cdn.flexmonster.com/flexmonster.js"></script>
      </body>
    </html>

    Step 3. Add a container for Flexmonster

    Create a <div> container for the component:

    <!DOCTYPE html>
    <html>
      <head>
        <title>My jQuery/Flexmonster Project</title>
      </head>
      <body>
        <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
        <script src="https://cdn.flexmonster.com/flexmonster.js"></script>
    
        <div id="pivotContainer">The component will appear here</div>
      </body>
    </html>

    Step 4. Initialize the pivot table

    Add a simple script to embed the component:

    <!DOCTYPE html>
    <html>
      <head>
        <title>My jQuery/Flexmonster Project</title>
      </head>
      <body>
        <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
        <script src="https://cdn.flexmonster.com/flexmonster.js"></script>
    
        <div id="pivotContainer">The component will appear here</div>
        <script>
          var pivot = $("#pivotContainer").flexmonster({
              componentFolder: "https://cdn.flexmonster.com/",            
              toolbar: true
          });
        </script> 
      </body>
    </html>

    Step 5. Load a sample report

    To see some data on the grid, add the report attribute with the report URL:

    <!DOCTYPE html>
    <html>
      <head>
        <title>My jQuery/Flexmonster Project</title>
      </head>
      <body>
        <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
        <script src="https://cdn.flexmonster.com/flexmonster.js"></script>
       
        <div id="pivotContainer">The component will appear here</div>
        <script>
          var pivot = $("#pivotContainer").flexmonster({
              componentFolder: "https://cdn.flexmonster.com/",
              toolbar: true,
              report: "https://cdn.flexmonster.com/reports/report.json"
          });
        </script>
      </body>
    </html>

    Open the index.htmlfile in the browser — the component with a sample report is embedded into your project.

    Check out a sample on JSFiddle. If you have any problems — visit our troubleshooting section.

    Initial jQuery call to embed the component

    $("#pivotContainer").flexmonster({
    componentFolder: String,
    global: GlobalObject,
    width: Number | String,
    height: Number | String,
    report: ReportObject | String,
    toolbar: Boolean,
    customizeCell: Function,
    licenseKey: String
    })

    [starting from version 2.3]

    Embeds the component into the HTML page.
    As a parameter the jQuery call gets #pivotContainer – this is the id of the HTML element that you want to have as the container for the component.
    This method allows you to insert the component into your HTML page and to provide it with all the necessary information for the initialization.

    Starting from version 2.3 you can preset options for all reports using the GlobalObject.

    Note Do not forget to import jQuery and flexmonster.js before you start working with it.

    Parameters

    Parameter/Type Description
    componentFolder
    String
    optional The URL of the component’s folder that contains all the necessary files. It is also used as the base URL for report files, localization files, styles, and images.
    Default value"flexmonster/".
    global
    GlobalObject
    optional Allows you to preset options for all reports. These options can be overridden for specific reports.
    width
    Number | String
    optional The width of the component on the page (either in pixels or as a percentage).
    Default value"100%".
    height
    Number | String
    optional The height of the component on the page (either in pixels or as a percentage).
    Default value: 500.
    report
    ReportObject | String
    optional The property to set a report. It can be an inline ReportObject or a URL to a report. Specify the report as a URL if your report is:
    • Stored in a JSON file.
    • Returned by a server-side script.
    XML reports are also supported for backward compatibility.
    toolbar
    Boolean
    optional The parameter to embed the Toolbar (true) or not (false).
    Default value: false.
    customizeCell
    Function
    optional Allows customizing separate cells. For more info, take a look at customizeCell definition and examples.
    customizeContextMenu
    Function
    optional Allows customizing the context menu. For more info, take a look at customizeContextMenu definition and examples.
    licenseKey
    String
    optional The license key.

    Event handlers can also be set as properties for the jQuery call. Check out the list here.

    All of the parameters are optional. If you run $("#pivotContainer").flexmonster() – an empty component without the Toolbar will be added with the default width and height.

    Returns

    Object - the reference to the embedded pivot table. If you want to work with multiple instances on the same page use these objects. All API calls are available through them.

    After initialization, you can obtain an instance reference to the created component by using this selector:
    var pivot = $("#pivot").data("flexmonster");

    Installation troubleshooting

    If you are facing any problems embedding the component, go to the page where the component should be displayed and open the browser console to check for any errors. Try the following steps:

    • If you get the alert "Flexmonster: jQuery is not loaded.", check the path to jQuery in your HTML page.
    • If the page is blank and you see the following error in the console: "Uncaught TypeError: $(...).flexmonster is not a function", check the path to Flexmonster in your HTML page.
    • If you get the alert "Unable to load dependencies. Please use 'componentFolder' parameter to set the path to 'flexmonster' folder.", add the componentFolder parameter to your $.flexmonster() call (e.g., "https://cdn.flexmonster.com/"):
      <div id="pivotContainer">The component will appear here</div> 
      <script src="https://cdn.flexmonster.com/lib/jquery.min.js"></script>
      <script src="https://cdn.flexmonster.com/flexmonster.js"></script>

      <script>
      var pivot = $("#pivotContainer").flexmonster({
      toolbar: true,
      // set the appropriate path
      componentFolder: "https://cdn.flexmonster.com/",
      });
      </script>
    • If you get the error "Uncaught TypeError: Cannot set property '_generatePosition' of undefined" or something similar, try updating the jQuery UI. The minimum recommended version is 1.9.2.
    • If you get the error "Uncaught TypeError: $.parseXML is not a function" or something similar, try updating jQuery. The minimum recommended version is 1.7.

    What's next?

☝️Small business or a startup? See if you qualify for our special offer.
+
All documentation
  • Introduction
  • Connecting to data source
  • Browser compatibility
  • Documentation for older versions
  • Integration with Angular

    This tutorial will help you integrate Flexmonster with Angular. Our component is compatible with the latest Angular 19 as well as earlier versions.

    Flexmonster has a 30-day free trial, with no registration required to start the evaluation. You can also test the component using our sample Angular project or the Angular pivot table demo.

    Prerequisites

    Note Node.js and Angular versions must be compatible. Check out the version compatibility guide.

    Step 1. (optional) Create an Angular application

    Skip this step if you already have an Angular app.

    Сreate an Angular app by running the following command in the console:

    ng new flexmonster-project --ssr=false && cd flexmonster-project

    Step 2. Get Flexmonster

    Get Flexmonster for Angular by running the following command inside your project:

    flexmonster add ngx-flexmonster

    This command downloads the ngx-flexmonster wrapper to node_modules/ and adds it as a dependency to package.json.

    Note This wrapper is Ivy-compatible and works only with Angular 14 and later. If you want to use Flexmonster in Angular 5 through 15, install the ng-flexmonster wrapper.

    Step 3. Embed Flexmonster

    Step 3.1. Import FlexmonsterPivotModule into your component (e.g., src/app/app.component.ts):

    import { Component } from "@angular/core";
    import { FlexmonsterPivotModule } from "ngx-flexmonster";
    
    @Component({
      selector: 'app-root',
      standalone: true,
      imports: [FlexmonsterPivotModule],
      templateUrl: './app.component.html',
      styleUrl: './app.component.css'
    })
    export class AppComponent {
      // ...
    }

    If you are using NgModules instead of component imports, add FlexmonsterPivotModule to your NgModule (e.g., src/app/app.module.ts):

    import { FlexmonsterPivotModule } from "ngx-flexmonster";
    
    @NgModule({
      // ...
      imports: [
        FlexmonsterPivotModule,
        // Other imports
      ],
      // ...
    })

    Step 3.2. Import Flexmonster styles (e.g., in src/styles.css):

    @import "flexmonster/flexmonster.min.css";

    Step 3.3. Create a FlexmonsterPivot component instance using the <fm-pivot> tag (e.g., in src/app/app.component.html):

    <fm-pivot
     [toolbar]="true">
    </fm-pivot>

    The toolbar is one of the FlexmonsterPivot input properties. Learn more about the FlexmonsterPivot component.

    Step 4. Run the application

    Run your application from the console:

    ng serve --open

    Open your project in the browser to see the result.

    You can also watch our video tutorial that covers the integration process for the ng-flexmonster wrapper. The integration process for the ngx-flexmonster wrapper is the same:

    Usage examples

    We prepared the following examples of Flexmonster usage:

    See also

Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • All documentation

    Integration with React

    This tutorial will help you integrate Flexmonster with React.

    Flexmonster has a 30-day free trial, with no registration required to start the evaluation. You can also test the component in our sample React project.

    If you are using React with Next.js, see Integration with Next.js.

    Prerequisites

    Step 1. (optional) Create a React application

    Skip this step if you already have a React app.

    Step 1.1. Create a React app from the console using Vite. You can choose an ES6 or a TypeScript project template:

    ES6

    # For npm 7 and later
    npm create vite@latest flexmonster-project -- --template react
    
    # For npm 6
    npm create vite@latest flexmonster-project --template react

    TypeScript

    # For npm 7 and later
    npm create vite@latest flexmonster-project -- --template react-ts
    
    # For npm 6
    npm create vite@latest flexmonster-project --template react-ts

    Step 1.2. Install npm dependencies needed for the project:

    cd flexmonster-project
    npm install

    Step 2. Get Flexmonster

    To get Flexmonster for React, run the following command inside your project:

    flexmonster add react-flexmonster

    This command downloads the react-flexmonster wrapper to node_modules/ and adds it as a dependency to package.json.

    Step 3. Embed Flexmonster

    ES6

    Step 3.1. Import Flexmonster styles (e.g., into src/index.css):

    @import "flexmonster/flexmonster.css";

    Step 3.2. Import the FlexmonsterReact component (e.g., into src/App.jsx):

    import * as FlexmonsterReact from "react-flexmonster";

    Step 3.3. Insert the FlexmonsterReact.Pivot component (e.g., into src/App.jsx):

    function App() {
      return (
        <div className="App">
          <FlexmonsterReact.Pivot
           toolbar={true}
          />
        </div>
      );
    }

    The toolbar is one of the FlexmonsterReact.Pivot props. Learn more about the FlexmonsterReact.Pivot component.

    TypeScript

    Step 3.1. Import Flexmonster styles (e.g., into src/index.css):

    @import "flexmonster/flexmonster.css";

    Step 3.2. Import the FlexmonsterReact component (e.g., into src/App.tsx):

    import * as FlexmonsterReact from "react-flexmonster";

    Step 3.3. Insert the FlexmonsterReact.Pivot component (e.g., into src/App.tsx):

    function App() {
      return (
        <div className="App">
          <FlexmonsterReact.Pivot
           toolbar={true}
          />
        </div>
      );
    }

    The toolbar is one of the FlexmonsterReact.Pivot props. Learn more about the FlexmonsterReact.Pivot component.

    Step 4. Run the application

    Run your application from the console:

    npm run dev

    Open your project in the browser to see the result.

    Usage examples

    We prepared the following examples of Flexmonster usage:

    See also

Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • All documentation

    Integration with Vue 3

    This tutorial will help you integrate Flexmonster with Vue 3. Watch the tutorial in the video format: Vue pivot table guide.

    Flexmonster has a 30-day free trial, with no registration required to start the evaluation. You can also test the component in our sample Vue 3 project.

    To integrate with Vue 2, see Integration with Vue 2.

    Prerequisites

    Step 1. (optional) Create a Vue 3 application

    Skip this step if you already have a Vue 3 app.

    Step 1.1. Start creating a Vue 3 app with create-vue. You can create an ES6-based or TypeScript-based project:

    ES6

    npm create vue@latest

    You will be prompted to choose optional features for the project. For simplicity, choose No for all the features.

    TypeScript

    npm create vue@latest

    You will be prompted to choose additional features for the project. Choose Yes for TypeScript to create a TypeScript project. For simplicity, choose No for other features.

    Step 1.2. Install npm dependencies needed for the project:

    cd <your-project-name> && npm install

    Learn more about creating a new project in the Vue documentation.

    Step 2. Get Flexmonster

    To get Flexmonster for Vue, run the following command inside your project:

    flexmonster add vue-flexmonster

    This command downloads the vue-flexmonster wrapper to node_modules/ and adds it as a dependency to package.json.

    Step 3. Embed Flexmonster

    Step 3.1. If your project is TypeScript-based, declare the vue-flexmonster/vue3 module in the env.d.ts file:

    /// <reference types="vite/client" />
    
    declare module "vue-flexmonster/vue3"

    Note If your project was generated by Vue CLI, the declare module "vue-flexmonster/vue3" line should be added to the src/shims-vue.d.ts file.

    Step 3.2. Import vue-flexmonster/vue3 in the component where you need the pivot table (e.g., in src/App.vue):

    ES6

    <script>
    // Import the Pivot component and CSS styles
    import Pivot from "vue-flexmonster/vue3";
    import "flexmonster/flexmonster.css";
    
    export default {
      name: 'App',
      // Register the Pivot component with the components option
      components: {
        Pivot,
      },
    };
    </script>

    TypeScript

    <script lang="ts">
    // Import the Pivot component and CSS styles
    import Pivot from "vue-flexmonster/vue3";
    import "flexmonster/flexmonster.css";
    
    import { defineComponent } from 'vue';
    
    export default defineComponent({
      name: 'App',
      // Register the Pivot component with the components option
      components: {
        Pivot,
      },
    });
    </script>

    Note In the code snippet above, Flexmonster is added to the Options API project. To embed Flexmonster when using Composition API, see this example: Interacting with Flexmonster when using Composition API.

    Step 3.3. Use the <Pivot> tag to add a Flexmonster instance to the chosen component (e.g., src/App.vue):

    <template>
      <Pivot
        toolbar
      />
    </template>

    The toolbar is one of the <Pivot> props. Learn more about the <Pivot> component.

    Step 4. Run the application

    Run your application from the console:

    npm run dev

    Open your project in the browser to see the result.

    You can also watch our video tutorial that covers the integration process:

    Usage examples

    We prepared the following examples of Flexmonster usage:

    See also

Follow this tutorial to integrate Flexmonster with the Svelte framework. Watch the tutorial in the video format: Svelte pivot table guide.
This guide demonstrates the TypeScript-based integration. To use vanilla JavaScript, follow the same steps without type declarations and lang="ts" in the <script> tag.
Flexmonster has a 30-day free trial, with no registration required to start the evaluation. You can also test the component using our sample Svelte project.
Skip this step if you already have a Svelte project.
Сreate a Svelte project by running the following commands in the console:
npx sv create fm-svelte-app
cd fm-svelte-app
You will be prompted to choose configurations for the project. For simplicity, choose the default options for all the features.
To get Flexmonster for Svelte, run the following command inside your project:
npm install svelte-flexmonster --save-exact
Note We recommend installing Flexmonster with the --save-exact flag to avoid unexpected component updates.
Step 3.1. Import Flexmonster in the page where you need the pivot table (e.g., src/routes/+page.svelte):
<script lang="ts">
import { Flexmonster } from "svelte-flexmonster";
</script>
Step 3.2. If your project has a global stylesheet (e.g., src/styles.css), import the Flexmonster styles there:
@import "flexmonster/flexmonster.min.css";
Alternatively, you can add Flexmonster styles to the <script> section of your page (e.g., src/routes/+page.svelte):
<script lang="ts">
import { Flexmonster } from "svelte-flexmonster";
import "flexmonster/flexmonster.css";
</script>
Step 3.3. Use the <Flexmonster> tag to add a Flexmonster instance to the chosen component (e.g., src/routes/+page.svelte):
<script lang="ts">
import { Flexmonster } from "svelte-flexmonster";
</script>
<div>
<Flexmonster
toolbar
/>
</div>
Run your project from the console:
npm run dev
To see the result, open http://localhost:5173/ in your browser. To shut down the project from the console, press Ctrl + C (Control + C on macOS).
You can also watch our video tutorial that covers the integration process:
We prepared the following examples of Flexmonster usage:
If you run into any issues during the integration, visit our troubleshooting page.
Can't find your answer?
Visit the FAQ
Flexmonster Pivot Table & Charts is a JavaScript pivot table component for adding interactive reporting and data analysis to web applications. Users can summarize, filter, sort, and explore data in pivot tables and charts, drill into results, and export reports.
Flexmonster works in plain JavaScript and TypeScript projects. It also integrates with React, Next.js, Angular, Vue, Blazor, and other technologies. See all integration options.
Flexmonster supports JSON and CSV files, SQL databases, MongoDB, Elasticsearch, and Microsoft Analysis Services (SSAS). You can also connect other data sources through your own backend. See supported data sources.
Flexmonster offers licenses for internal corporate use, SaaS products, and OEM distribution. Pricing varies by license and plan. SaaS projects can also use the free SaaS Entry license during development. Learn more on the pricing page.
Yes. Flexmonster offers a 30-day free trial that lets you evaluate all its features. No credit card is required. The trial version has a watermark.
To get started with Flexmonster, follow our integration guide.